# !/usr/bin/env Python3
# -*- coding:utf-8 -*-
# Team:HiLab
# Author:Yu Tao
# Date:2022/7/5 11:35
# Tool:PyCharm
# Email:yuao_11260103@163.com
# Project:msDAWG
# ------ ------
# use gradientBoost to FS
# ------ ------
import sys
from datetime import datetime
from sklearn.ensemble import GradientBoostingClassifier, AdaBoostClassifier
from scripts.feature_select import SFM
from scripts.evaluation import *
from load_data import *

# dt = datetime.today()
# file_name = str(dt.day) + '-' + str(dt.hour) + '-' + str(dt.minute)
# #
# log_print = open(file_name + '.log', 'w')
# sys.stdout = log_print
# sys.stderr = log_print

print('start GB random_state')
features_num = [200, 100, 100, 100, 200, 100, 100]  # GB
# features_num = [150, 250, 100, 100, 250, 100, 100]  # Ada

datasets = ['HIP_CER', 'ICC_rms', 'SIMS',
            'OvarianL91-162',
            'PanINDataH101-80',
            'OvarianL16-100-100',
            'JNCIL69-190-63']
for i in range(7):
    print(datasets[i])
    X = np.load('data/' + datasets[i] + '_X.npy')
    y = np.load('data/' + datasets[i] + '_y.npy', allow_pickle=True).astype(np.float32)
    data_dict = {'X_train': X,
                 'y_train': y,
                 'X_test': X,
                 'y_test': y}
    # model = AdaBoostClassifier(random_state=4) #random_state do not influence result
    model = GradientBoostingClassifier(random_state=1)
    data_X_selected = SFM(model, data_dict=data_dict, feature_num=features_num[i])
    print(data_X_selected.shape)
    np.save('data/Adaboost_FS/' + datasets[i] + '_ada_.npy', data_X_selected)
    X_train, X_test, y_train, y_test = split_train_test(data_X_selected, y)
    precision, recall, accuracy, aucc = all_evaluate(X_train,
                                                     X_test,
                                                     y_train,
                                                     y_test)
