# !/usr/bin/env Python3
# -*- coding:utf-8 -*-
# Team:HiLab
# Author:Yu Tao
# Date:2022/6/24 19
# Tool:PyCharm
# Email:yuao_11260103@163.com
# Project:msDAWG
# ------ ------
#  construct feature by 3coderAE , then shap
# ------ ------

from scripts.feature_select import *
from param_class import Dataset_Param
import torch
import random
import warnings
from sandwichAE_FC import three_coder_AE_feature_construct
import sys
from datetime import datetime

warnings.filterwarnings('ignore')
seed = 42
torch.manual_seed(seed)
torch.cuda.manual_seed_all(seed)
np.random.seed(seed)
random.seed(seed)
torch.backends.cudnn.deterministic = True
dt = datetime.today()
file_name = str(dt.day) + '-' + str(dt.hour) + '-' + str(dt.minute)

log_print = open(file_name + '.log', 'w')
sys.stdout = log_print
sys.stderr = log_print

for data_index in range(5, 8):
    for b_s in range(10, 21, 10):
        for lr in [1e-4, 5e-4, 1e-5]:
            for epo in [50, 100]:
                data = Dataset_Param(data_index, b_s, lr, epo)
                X_train = np.load('data/shap500/' + data.name + '_train_X.npy')
                X_test = np.load('data/shap500/' + data.name + '_test_X.npy')
                y_train = np.load('data/82split/' + data.name + '_train_Y.npy', allow_pickle=True).astype(np.float32)
                y_test = np.load('data/82split/' + data.name + '_test_Y.npy', allow_pickle=True).astype(np.float32)
                model = three_coder_AE_feature_construct(X_train, y_train, Dataset_Param=data)
